/*
Copyright Kumori.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by informer-gen. DO NOT EDIT.

package v1

import (
	time "time"

	getambassadoriov1 "gitlab.com/mandanga-public/sub1/sub2/client-go/pkg/apis_ambassador/getambassador.io/v1"
	versioned "gitlab.com/mandanga-public/sub1/sub2/client-go/pkg/generated_ambassador/clientset/versioned"
	internalinterfaces "gitlab.com/mandanga-public/sub1/sub2/client-go/pkg/generated_ambassador/informers/externalversions/internalinterfaces"
	v1 "gitlab.com/mandanga-public/sub1/sub2/client-go/pkg/generated_ambassador/listers/getambassador.io/v1"
	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	runtime "k8s.io/apimachinery/pkg/runtime"
	watch "k8s.io/apimachinery/pkg/watch"
	cache "k8s.io/client-go/tools/cache"
)

// KubernetesEndpointResolverInformer provides access to a shared informer and lister for
// KubernetesEndpointResolvers.
type KubernetesEndpointResolverInformer interface {
	Informer() cache.SharedIndexInformer
	Lister() v1.KubernetesEndpointResolverLister
}

type kubernetesEndpointResolverInformer struct {
	factory          internalinterfaces.SharedInformerFactory
	tweakListOptions internalinterfaces.TweakListOptionsFunc
	namespace        string
}

// NewKubernetesEndpointResolverInformer constructs a new informer for KubernetesEndpointResolver type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewKubernetesEndpointResolverInformer(client versioned.Interface, namespace string, resyncPeriod time.Duration, indexers cache.Indexers) cache.SharedIndexInformer {
	return NewFilteredKubernetesEndpointResolverInformer(client, namespace, resyncPeriod, indexers, nil)
}

// NewFilteredKubernetesEndpointResolverInformer constructs a new informer for KubernetesEndpointResolver type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewFilteredKubernetesEndpointResolverInformer(client versioned.Interface, namespace string, resyncPeriod time.Duration, indexers cache.Indexers, tweakListOptions internalinterfaces.TweakListOptionsFunc) cache.SharedIndexInformer {
	return cache.NewSharedIndexInformer(
		&cache.ListWatch{
			ListFunc: func(options metav1.ListOptions) (runtime.Object, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.GetambassadorV1().KubernetesEndpointResolvers(namespace).List(options)
			},
			WatchFunc: func(options metav1.ListOptions) (watch.Interface, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.GetambassadorV1().KubernetesEndpointResolvers(namespace).Watch(options)
			},
		},
		&getambassadoriov1.KubernetesEndpointResolver{},
		resyncPeriod,
		indexers,
	)
}

func (f *kubernetesEndpointResolverInformer) defaultInformer(client versioned.Interface, resyncPeriod time.Duration) cache.SharedIndexInformer {
	return NewFilteredKubernetesEndpointResolverInformer(client, f.namespace, resyncPeriod, cache.Indexers{cache.NamespaceIndex: cache.MetaNamespaceIndexFunc}, f.tweakListOptions)
}

func (f *kubernetesEndpointResolverInformer) Informer() cache.SharedIndexInformer {
	return f.factory.InformerFor(&getambassadoriov1.KubernetesEndpointResolver{}, f.defaultInformer)
}

func (f *kubernetesEndpointResolverInformer) Lister() v1.KubernetesEndpointResolverLister {
	return v1.NewKubernetesEndpointResolverLister(f.Informer().GetIndexer())
}
